import _extends from "@babel/runtime/helpers/esm/extends";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _createSuper from "@babel/runtime/helpers/esm/createSuper";
import * as React from 'react';
import { SubMenu as RcSubMenu } from 'rc-menu';
import classNames from 'classnames';
import omit from "rc-util/es/omit";
import MenuContext from './MenuContext';
import { isValidElement } from '../_util/reactNode';

var SubMenu = /*#__PURE__*/function (_React$Component) {
  _inherits(SubMenu, _React$Component);

  var _super = _createSuper(SubMenu);

  function SubMenu() {
    _classCallCheck(this, SubMenu);

    return _super.apply(this, arguments);
  }

  _createClass(SubMenu, [{
    key: "renderTitle",
    value: function renderTitle(inlineCollapsed) {
      var _this$props = this.props,
          icon = _this$props.icon,
          title = _this$props.title,
          level = _this$props.level;
      var prefixCls = this.context.prefixCls;

      if (!icon) {
        return inlineCollapsed && level === 1 && title && typeof title === 'string' ? /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-inline-collapsed-noicon")
        }, title.charAt(0)) : title;
      } // inline-collapsed.md demo 依赖 span 来隐藏文字,有 icon 属性，则内部包裹一个 span
      // ref: https://github.com/ant-design/ant-design/pull/23456


      var titleIsSpan = isValidElement(title) && title.type === 'span';
      return /*#__PURE__*/React.createElement(React.Fragment, null, icon, titleIsSpan ? title : /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-title-content")
      }, title));
    }
  }, {
    key: "render",
    value: function render() {
      var popupClassName = this.props.popupClassName;
      var _this$context = this.context,
          prefixCls = _this$context.prefixCls,
          inlineCollapsed = _this$context.inlineCollapsed,
          antdMenuTheme = _this$context.antdMenuTheme;
      return /*#__PURE__*/React.createElement(MenuContext.Provider, {
        value: _extends(_extends({}, this.context), {
          firstLevel: false
        })
      }, /*#__PURE__*/React.createElement(RcSubMenu, _extends({}, omit(this.props, ['icon']), {
        title: this.renderTitle(inlineCollapsed),
        popupClassName: classNames(prefixCls, "".concat(prefixCls, "-").concat(antdMenuTheme), popupClassName)
      })));
    }
  }]);

  return SubMenu;
}(React.Component);

SubMenu.contextType = MenuContext;
export default SubMenu;